package org.apache.maven.linkcheck;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache Maven" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache Maven", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;



import junit.framework.TestCase;

/**
 * @author Ben Walding
 *
 */
public class LinkCheckTest extends TestCase
{
  String baseDir;

  public void setUp()
  {
     baseDir = System.getProperty("basedir");
  }

  public void testScan() throws Exception
  {
    File f = new File(baseDir + "/src/test-resources");
    LinkCheck lc = new LinkCheck();
    lc.setBasedir(f);
    lc.setOutput(new File(baseDir + "/target/linkcheck.xml"));
    lc.setOutputEncoding("ISO8859-1");
    lc.setCache(baseDir + "/target/linkcheck-cache.xml");
    lc.doExecute();

    Iterator iter = lc.getFiles().iterator();
    Map map = new HashMap();
    while (iter.hasNext())
    {
      FileToCheck ftc = (FileToCheck) iter.next();
      map.put(ftc.getName(), ftc);
    }

    assertEquals("files.size()", 7, lc.getFiles().size());

    check(map, "nolink.html", 0);
    check(map, "test-resources/nolink.html", 0);
    check(map, "test-resources/test1/test1.html", 2);
    check(map, "test-resources/test1/test2.html", 0);
    check(map, "test1/test1.html", 1);
    check(map, "testA.html", 3);
    
    //index-all.html should get parsed, but is currently having problems.
    //check(map, "index-all.html", 1);

  }

  private void check(Map map, String name, int linkCount)
  {
    FileToCheck ftc;

    ftc = (FileToCheck) map.get(name);
    assertNotNull(name, ftc);

    /*if (ftc.getResults().size() != linkCount) {
        
    }*/

    assertEquals(name + ".getLinks().size()", linkCount, ftc.getResults().size());
  }

}
